diff --git a/game/client/src/main/java/net/minecraft/client/gui/Gui.java b/game/client/src/main/java/net/minecraft/client/gui/Gui.java
index 355a19db6..b3abca07c 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/Gui.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/Gui.java
@@ -768,41 +749,41 @@ public class Gui
         }
     }
 
-    public void drawIconTexture(int x0, int y0, int x1, int y1, int u0, int v0, int u1, int v1, IconCoordinate coordinate) {
+    public void drawIconTexture(final int x0, final int y0, final int x1, final int y1, final int u0, final int v0, final int u1, final int v1, final IconCoordinate coordinate) {
         coordinate.parentAtlas.bind();
 
-        double realU0 = coordinate.getSubIconU(u0 /((double)coordinate.width));
-        double realU1 = coordinate.getSubIconU(u1 /((double)coordinate.width));
-        double realV0 = coordinate.getSubIconV(v0 /((double)coordinate.height));
-        double realV1 = coordinate.getSubIconV(v1 /((double)coordinate.height));
+        final double realU0 = coordinate.getSubIconU(u0 /((double)coordinate.width));
+        final double realU1 = coordinate.getSubIconU(u1 /((double)coordinate.width));
+        final double realV0 = coordinate.getSubIconV(v0 /((double)coordinate.height));
+        final double realV1 = coordinate.getSubIconV(v1 /((double)coordinate.height));
 
 //        System.out.printf("%s, %s, %s, %s\n", realU0, realU1, realV0, realV1);
 
-        Tessellator t = Tessellator.instance;
+        final Tessellator t = Tessellator.instance;
         t.startDrawingQuads();
-        t.addVertexWithUV(x0, y1, zLevel, realU0, realV1);
-        t.addVertexWithUV(x1, y1, zLevel, realU1, realV1);
-        t.addVertexWithUV(x1, y0, zLevel, realU1, realV0);
-        t.addVertexWithUV(x0, y0, zLevel, realU0, realV0);
+        t.addVertexWithUV(x0, y1, this.zLevel, realU0, realV1);
+        t.addVertexWithUV(x1, y1, this.zLevel, realU1, realV1);
+        t.addVertexWithUV(x1, y0, this.zLevel, realU1, realV0);
+        t.addVertexWithUV(x0, y0, this.zLevel, realU0, realV0);
         t.draw();
     }
 
-    public void drawIconTextureDouble(double x0, double y0, double x1, double y1, double u0, double v0, double u1, double v1, IconCoordinate coordinate) {
+    public void drawIconTextureDouble(final double x0, final double y0, final double x1, final double y1, final double u0, final double v0, final double u1, final double v1, final IconCoordinate coordinate) {
         coordinate.parentAtlas.bind();
 
-        double realU0 = coordinate.getSubIconU(u0 /((double)coordinate.width));
-        double realU1 = coordinate.getSubIconU(u1 /((double)coordinate.width));
-        double realV0 = coordinate.getSubIconV(v0 /((double)coordinate.height));
-        double realV1 = coordinate.getSubIconV(v1 /((double)coordinate.height));
+        final double realU0 = coordinate.getSubIconU(u0 /((double)coordinate.width));
+        final double realU1 = coordinate.getSubIconU(u1 /((double)coordinate.width));
+        final double realV0 = coordinate.getSubIconV(v0 /((double)coordinate.height));
+        final double realV1 = coordinate.getSubIconV(v1 /((double)coordinate.height));
 
 //        System.out.printf("%s, %s, %s, %s\n", realU0, realU1, realV0, realV1);
 
-        Tessellator t = Tessellator.instance;
+        final Tessellator t = Tessellator.instance;
         t.startDrawingQuads();
-        t.addVertexWithUV(x0, y1, zLevel, realU0, realV1);
-        t.addVertexWithUV(x1, y1, zLevel, realU1, realV1);
-        t.addVertexWithUV(x1, y0, zLevel, realU1, realV0);
-        t.addVertexWithUV(x0, y0, zLevel, realU0, realV0);
+        t.addVertexWithUV(x0, y1, this.zLevel, realU0, realV1);
+        t.addVertexWithUV(x1, y1, this.zLevel, realU1, realV1);
+        t.addVertexWithUV(x1, y0, this.zLevel, realU1, realV0);
+        t.addVertexWithUV(x0, y0, this.zLevel, realU0, realV0);
         t.draw();
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/HeldItemTooltipElement.java b/game/client/src/main/java/net/minecraft/client/gui/HeldItemTooltipElement.java
index b23d0f8b8..f0433812c 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/HeldItemTooltipElement.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/HeldItemTooltipElement.java
@@ -4,6 +4,8 @@ import static org.lwjgl.opengl.GL11.*;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.option.Option;
+import net.minecraft.client.render.font.renderhelper.FontHelper;
+import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.client.util.helper.Colors;
 import net.minecraft.core.util.helper.Time;
@@ -126,7 +128,7 @@ public class HeldItemTooltipElement extends Gui {
 			glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
 		}
 
-		mc.font.drawStringWithShadow(string, x - (mc.font.getStringWidth(string)) / 2, y, rgb);
+		FontHelper.renderCentered(Tessellator.instance, this.string, x, y).setShadow().setColor(rgb).call(mc.font);
 
 		glDisable(GL_BLEND);
 		glEnable(GL_ALPHA_TEST);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/IntegerSliderElement.java b/game/client/src/main/java/net/minecraft/client/gui/IntegerSliderElement.java
index cfc3a7f29..efeda51d5 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/IntegerSliderElement.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/IntegerSliderElement.java
@@ -1,6 +1,5 @@
 package net.minecraft.client.gui;
 
-import net.minecraft.client.render.Font;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import org.lwjgl.opengl.GL11;
@@ -12,6 +11,7 @@ public class IntegerSliderElement extends ButtonElement {
 
 	public int sliderValue;
 	public boolean dragging;
+	public boolean renderText = true;
 	private OptionToggleable<?> option;
 
 	public IconCoordinate backgroundTexture;
@@ -67,7 +67,6 @@ public class IntegerSliderElement extends ButtonElement {
 	public void drawButton(Minecraft mc, int mouseX, int mouseY) {
 		if (!visible) return;
 
-		Font font = mc.font;
 		boolean mouseOver = mouseX >= xPosition && mouseY >= yPosition && mouseX < xPosition + width && mouseY < yPosition + height;
 		int state = getButtonState(mouseOver);
 
@@ -108,8 +107,10 @@ public class IntegerSliderElement extends ButtonElement {
 				textColor = 0xFFFFA0;
 				break;
 		}
-		drawStringCentered(font, displayString, xPosition + width / 2, yPosition + (height - 8) / 2, textColor);
 
+		if (this.renderText) {
+			drawStringCenteredShadow(mc.font, displayString, xPosition + width / 2, yPosition + (height - 8) / 2, textColor);
+		}
 	}
 
 	@Override
diff --git a/game/client/src/main/java/net/minecraft/client/gui/Screen.java b/game/client/src/main/java/net/minecraft/client/gui/Screen.java
index 8176b3eb0..76015a8f2 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/Screen.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/Screen.java
@@ -7,15 +7,14 @@ import java.util.List;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.input.controller.ControllerInput;
-import net.minecraft.client.render.Font;
+import net.minecraft.client.render.font.FontRenderer;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.window.CursorShape;
-import net.minecraft.client.render.window.GameWindowGLFW;
 import net.minecraft.client.util.debug.DebugRender;
 import net.minecraft.client.input.InputType;
 
 import net.minecraft.core.sound.SoundCategory;
-import org.lwjgl.glfw.GLFW;
+import org.jetbrains.annotations.Nullable;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.input.Mouse;
 import org.lwjgl.opengl.GL11;
@@ -26,16 +25,17 @@ public abstract class Screen extends Gui {
     public int height;
     public List<ButtonElement> buttons;
     public boolean passEvents;
-    public Font font;
+    public FontRenderer fontRenderer;
     protected ButtonElement clickedButton;
     final Screen parentScreen;
     private CursorShape desiredCursor = CursorShape.ARROW;
 
-    public Screen(Screen parent) {
-        buttons = new ArrayList<>();
-        passEvents = false;
-        clickedButton = null;
-        parentScreen = parent;
+    public Screen(@Nullable final Screen parent) {
+        super();
+        this.buttons = new ArrayList<>();
+        this.passEvents = false;
+        this.clickedButton = null;
+        this.parentScreen = parent;
     }
 
     public Screen() {
@@ -108,7 +108,7 @@ public abstract class Screen extends Gui {
 
     public void opened(Minecraft mc, int width, int height) {
         this.mc = mc;
-        font = mc.font;
+        fontRenderer = mc.font;
         this.width = width;
         this.height = height;
         buttons.clear();
@@ -241,6 +241,6 @@ public abstract class Screen extends Gui {
     }
 
     public void updateFont() {
-        this.font = mc.font;
+        this.fontRenderer = this.mc.font;
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenAddServer.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenAddServer.java
index ae8734f2e..acb97bfb7 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenAddServer.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenAddServer.java
@@ -36,10 +36,10 @@ public class ScreenAddServer extends Screen
         buttons.clear();
         buttons.add(buttonSave = new ButtonElement(0, width / 2 - 100, height / 4 + 96 + 12, stringtranslate.translateKey("gui.add_server.button.save")));
         buttons.add(buttonCancel = new ButtonElement(1, width / 2 - 100, height / 4 + 120 + 12, stringtranslate.translateKey("gui.add_server.button.cancel")));
-        serverNameTextField = new TextFieldElement(this, font, width / 2 - 100, (height / 4 - 10) + 18, 200, 20, "", "");
+        serverNameTextField = new TextFieldElement(this, fontRenderer, width / 2 - 100, (height / 4 - 10) + 18, 200, 20, "", "");
         serverNameTextField.isFocused = true;
         serverNameTextField.setMaxStringLength(32);
-        ipTextField = new TextFieldElement(this, font, width / 2 - 100, (height / 4 - 10) + 50 + 18, 200, 20, "", "");
+        ipTextField = new TextFieldElement(this, fontRenderer, width / 2 - 100, (height / 4 - 10) + 50 + 18, 200, 20, "", "");
         ipTextField.setMaxStringLength(128);
         buttons.add(buttonShowIp = new ButtonElement(2, width / 2 - 100, (height / 4 - 10) + 50 + 18 + 20 + 4, 200, 20, getShowIpLabel()));
         buttonSave.enabled = false;
@@ -135,9 +135,9 @@ public class ScreenAddServer extends Screen
     {
         I18n stringtranslate = I18n.getInstance();
         renderBackground();
-        drawStringCentered(font, stringtranslate.translateKey("gui.add_server.label.title"), width / 2, (height / 4 - 60) + 20, 0xffffff);
-        drawString(font, stringtranslate.translateKey("gui.add_server.label.server_name"), serverNameTextField.xPosition, serverNameTextField.yPosition - 14, 0xa0a0a0);
-        drawString(font, stringtranslate.translateKey("gui.add_server.label.ip_address"), ipTextField.xPosition, ipTextField.yPosition - 14, 0xa0a0a0);
+        drawStringCenteredShadow(fontRenderer, stringtranslate.translateKey("gui.add_server.label.title"), width / 2, (height / 4 - 60) + 20, 0xffffff);
+        drawStringShadow(fontRenderer, stringtranslate.translateKey("gui.add_server.label.server_name"), serverNameTextField.xPosition, serverNameTextField.yPosition - 14, 0xa0a0a0);
+        drawStringShadow(fontRenderer, stringtranslate.translateKey("gui.add_server.label.ip_address"), ipTextField.xPosition, ipTextField.yPosition - 14, 0xa0a0a0);
         ipTextField.drawTextBox();
         ipTextField.updateCursor(mc, mx, my);
         serverNameTextField.drawTextBox();
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenBadJavaArch.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenBadJavaArch.java
index 3449f27d0..f00bb7674 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenBadJavaArch.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenBadJavaArch.java
@@ -2,6 +2,7 @@ package net.minecraft.client.gui;
 
 import com.mojang.logging.LogUtils;
 import net.minecraft.core.lang.I18n;
+import net.minecraft.core.util.helper.MathHelper;
 import org.slf4j.Logger;
 
 import java.awt.*;
@@ -22,7 +23,7 @@ public class ScreenBadJavaArch extends Screen
         buttons.clear();
         String downloadString = i.translateKey("gui.bad_java_arch.button.download");
         buttons.add(new ButtonElement(0, width / 2 - 100, height / 4 + 120 + 12, i.translateKey("gui.bad_java_arch.button.continue")));
-        buttons.add(new ClickableLabelElement(1, width / 2 - 170 - font.getStringWidth(downloadString) / 2, (height / 4 - 60) + 60 + 64, downloadString, 0x7C99EA));
+        buttons.add(new ClickableLabelElement(1, width / 2 - 170 - MathHelper.ceil(fontRenderer.stringWidthDouble(downloadString) / 2), (height / 4 - 60) + 60 + 64, downloadString, 0x7C99EA));
     }
 
     @Override
@@ -58,11 +59,11 @@ public class ScreenBadJavaArch extends Screen
     {
         I18n i = I18n.getInstance();
         renderBackground();
-        drawStringCentered(font, i.translateKey("gui.bad_java_arch.label.title"), width / 2, (height / 4 - 60) + 20, 0xffffff);
-        drawString(font, i.translateKey("gui.bad_java_arch.label.body.1"), width / 2 - 170, (height / 4 - 60) + 60 + 0, 0xa0a0a0);
-        drawString(font, i.translateKey("gui.bad_java_arch.label.body.2"), width / 2 - 170, (height / 4 - 60) + 60 + 18, 0xa0a0a0);
-        drawString(font, i.translateKey("gui.bad_java_arch.label.body.3"), width / 2 - 170, (height / 4 - 60) + 60 + 27, 0xa0a0a0);
-        drawString(font, i.translateKey("gui.bad_java_arch.label.body.4"), width / 2 - 170, (height / 4 - 60) + 60 + 45, 0xa0a0a0);
+        drawStringCenteredShadow(fontRenderer, i.translateKey("gui.bad_java_arch.label.title"), width / 2, (height / 4 - 60) + 20, 0xffffff);
+        drawStringShadow(fontRenderer, i.translateKey("gui.bad_java_arch.label.body.1"), width / 2 - 170, (height / 4 - 60) + 60 + 0, 0xa0a0a0);
+        drawStringShadow(fontRenderer, i.translateKey("gui.bad_java_arch.label.body.2"), width / 2 - 170, (height / 4 - 60) + 60 + 18, 0xa0a0a0);
+        drawStringShadow(fontRenderer, i.translateKey("gui.bad_java_arch.label.body.3"), width / 2 - 170, (height / 4 - 60) + 60 + 27, 0xa0a0a0);
+        drawStringShadow(fontRenderer, i.translateKey("gui.bad_java_arch.label.body.4"), width / 2 - 170, (height / 4 - 60) + 60 + 45, 0xa0a0a0);
         super.render(mx, my, partialTick);
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenConflictWarning.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenConflictWarning.java
index ddf85e1a4..e3da98477 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenConflictWarning.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenConflictWarning.java
@@ -34,11 +34,11 @@ public class ScreenConflictWarning extends Screen
     {
         I18n i = I18n.getInstance();
         renderBackground();
-        drawStringCentered(font, i.translateKey("gui.conflict_warning.label.title"), width / 2, (height / 4 - 60) + 20, 0xffffff);
-        drawString(font, i.translateKey("gui.conflict_warning.label.body.1"), width / 2 - 140, (height / 4 - 60) + 60 + 0, 0xa0a0a0);
-        drawString(font, i.translateKey("gui.conflict_warning.label.body.2"), width / 2 - 140, (height / 4 - 60) + 60 + 18, 0xa0a0a0);
-        drawString(font, i.translateKey("gui.conflict_warning.label.body.3"), width / 2 - 140, (height / 4 - 60) + 60 + 27, 0xa0a0a0);
-        drawString(font, i.translateKey("gui.conflict_warning.label.body.4"), width / 2 - 140, (height / 4 - 60) + 60 + 45, 0xa0a0a0);
+        drawStringCenteredShadow(fontRenderer, i.translateKey("gui.conflict_warning.label.title"), width / 2, (height / 4 - 60) + 20, 0xffffff);
+        drawStringShadow(fontRenderer, i.translateKey("gui.conflict_warning.label.body.1"), width / 2 - 140, (height / 4 - 60) + 60 + 0, 0xa0a0a0);
+        drawStringShadow(fontRenderer, i.translateKey("gui.conflict_warning.label.body.2"), width / 2 - 140, (height / 4 - 60) + 60 + 18, 0xa0a0a0);
+        drawStringShadow(fontRenderer, i.translateKey("gui.conflict_warning.label.body.3"), width / 2 - 140, (height / 4 - 60) + 60 + 27, 0xa0a0a0);
+        drawStringShadow(fontRenderer, i.translateKey("gui.conflict_warning.label.body.4"), width / 2 - 140, (height / 4 - 60) + 60 + 45, 0xa0a0a0);
         super.render(mx, my, partialTick);
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenConnectFailed.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenConnectFailed.java
index e5a2070b3..afa150337 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenConnectFailed.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenConnectFailed.java
@@ -56,8 +56,8 @@ public class ScreenConnectFailed extends Screen
 	public void render(int mx, int my, float partialTick)
     {
         renderBackground();
-        drawStringCentered(font, errorMessage, width / 2, height / 2 - 50, 0xffffff);
-        drawStringCentered(font, errorDetail, width / 2, height / 2 - 10, 0xffffff);
+        drawStringCenteredShadow(fontRenderer, errorMessage, width / 2, height / 2 - 50, 0xffffff);
+        drawStringCenteredShadow(fontRenderer, errorDetail, width / 2, height / 2 - 10, 0xffffff);
         super.render(mx, my, partialTick);
     }
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenConnectToIp.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenConnectToIp.java
index 307ef8273..8bb58bb8b 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenConnectToIp.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenConnectToIp.java
@@ -28,7 +28,7 @@ public class ScreenConnectToIp extends Screen
         buttons.add(new ButtonElement(1, width / 2 - 100, height / 4 + 120 + 12, stringtranslate.translateKey("gui.connect_to_ip.button.cancel")));
         String s = mc.gameSettings.lastServer.value.replaceAll("_", ":");
         buttons.get(0).enabled = s.length() > 0;
-        textField = new TextFieldElement(this, font, width / 2 - 100, (height / 4 - 10) + 50 + 18, 200, 20, s, "");
+        textField = new TextFieldElement(this, fontRenderer, width / 2 - 100, (height / 4 - 10) + 50 + 18, 200, 20, s, "");
         textField.isFocused = true;
         textField.setMaxStringLength(128);
     }
@@ -84,8 +84,8 @@ public class ScreenConnectToIp extends Screen
     {
         I18n i18n = I18n.getInstance();
         renderBackground();
-        drawStringCentered(font, i18n.translateKey("gui.connect_to_ip.label.title"), width / 2, (height / 4 - 60) + 20, 0xffffff);
-        drawString(font, i18n.translateKey("gui.connect_to_ip.label.enter_ip"), width / 2 - 140, (height / 4 - 60) + 60 + 36, 0xa0a0a0);
+        drawStringCenteredShadow(fontRenderer, i18n.translateKey("gui.connect_to_ip.label.title"), width / 2, (height / 4 - 60) + 20, 0xffffff);
+        drawStringShadow(fontRenderer, i18n.translateKey("gui.connect_to_ip.label.enter_ip"), width / 2 - 140, (height / 4 - 60) + 60 + 36, 0xa0a0a0);
         textField.drawTextBox();
         textField.updateCursor(mc, mx, my);
         super.render(mx, my, partialTick);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenConnecting.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenConnecting.java
index f2b6cf798..9d28afb55 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenConnecting.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenConnecting.java
@@ -107,12 +107,12 @@ public class ScreenConnecting extends Screen
         I18n stringtranslate = I18n.getInstance();
         if(clientHandler == null)
         {
-            drawStringCentered(font, stringtranslate.translateKey("gui.connecting.label.connecting"), width / 2, height / 2 - 50, 0xffffff);
-            drawStringCentered(font, "", width / 2, height / 2 - 10, 0xffffff);
+            drawStringCenteredShadow(fontRenderer, stringtranslate.translateKey("gui.connecting.label.connecting"), width / 2, height / 2 - 50, 0xffffff);
+            drawStringCenteredShadow(fontRenderer, "", width / 2, height / 2 - 10, 0xffffff);
         } else
         {
-            drawStringCentered(font, stringtranslate.translateKey("gui.connecting.label.logging_in"), width / 2, height / 2 - 50, 0xffffff);
-            drawStringCentered(font, clientHandler.message, width / 2, height / 2 - 10, 0xffffff);
+            drawStringCenteredShadow(fontRenderer, stringtranslate.translateKey("gui.connecting.label.logging_in"), width / 2, height / 2 - 50, 0xffffff);
+            drawStringCenteredShadow(fontRenderer, clientHandler.message, width / 2, height / 2 - 10, 0xffffff);
         }
         super.render(mx, my, partialTick);
     }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenConsole.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenConsole.java
index e9574cef9..f39fb603f 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenConsole.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenConsole.java
@@ -7,15 +7,17 @@ import net.minecraft.client.console.LogMessageReceiver;
 import net.minecraft.client.console.syntax.RendererFactory;
 import net.minecraft.client.gui.text.ITextField;
 import net.minecraft.client.gui.text.TextFieldEditor;
-import net.minecraft.client.render.Font;
+import net.minecraft.client.render.font.FontMonospace;
 import net.minecraft.client.console.shell.RuntimeExecutor;
+import net.minecraft.client.render.font.FontRenderer;
+import net.minecraft.client.render.font.FontRendererDefault;
+import net.minecraft.client.render.font.renderhelper.FontHelper;
+import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.client.render.window.CursorShape;
-import net.minecraft.client.render.window.GameWindowGLFW;
 import net.minecraft.core.net.command.TextFormatting;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
-import org.lwjgl.glfw.GLFW;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.input.Mouse;
 import org.lwjgl.opengl.GL11;
@@ -36,7 +38,7 @@ public class ScreenConsole extends Screen {
 
         private final @NotNull Map<LogMessage.@NotNull Level, @NotNull TextFormatting> preludes = new HashMap<>();
 
-        private @Nullable Font font = null;
+        private @Nullable FontRenderer fontRenderer = null;
 
         private int width = 0;
         private int scroll = 0;
@@ -51,7 +53,8 @@ public class ScreenConsole extends Screen {
 
         public void init(final @NotNull Minecraft mc, final int width) {
             this.width = width;
-            this.font = new Font(mc, mc.gameSettings, mc.textureManager, true);
+            this.fontRenderer = new FontRendererDefault(new FontMonospace(mc.textureManager));
+            this.fontRenderer.init(mc.texturePackList);
 
             initWorkedLines();
             final @NotNull List<@NotNull String> workedLine = new ArrayList<>();
@@ -73,8 +76,8 @@ public class ScreenConsole extends Screen {
             final int lines = Math.min(heightLines, WORKED_LINES.size() - this.scroll);
             for (int i = lines - 1; i >= 0; i--) {
                 final @NotNull String line = WORKED_LINES.get((WORKED_LINES.size() - 1) - (i + this.scroll));
-                if (this.font != null) {
-                    this.font.drawString(line, x, y + getHeight(numLines) - LINE_HEIGHT - LINE_HEIGHT * i, 0xFF_CF_CF_CF);
+                if (this.fontRenderer != null) {
+                    FontHelper.render(Tessellator.instance, line, x, y + getHeight(numLines) - LINE_HEIGHT - LINE_HEIGHT * i).setColor(0xFF_CF_CF_CF).call(this.fontRenderer);
                 }
             }
             renderScrollIndicator(x, y, numLines);
@@ -136,7 +139,7 @@ public class ScreenConsole extends Screen {
         }
 
         private void formatString(final @NotNull LogMessage message, final @NotNull List<@NotNull String> out) {
-            if (this.font == null) {
+            if (this.fontRenderer == null) {
                 return;
             }
 
@@ -161,9 +164,9 @@ public class ScreenConsole extends Screen {
                         if (newFormat != null) {
                             nextFormat = newFormat;
                         }
-                        lineWidth -= this.font.getCharWidth(c) + this.font.getCharWidth(trimmedLine.charAt(i + 1));
+                        lineWidth -= this.fontRenderer.charWidth(c) + this.fontRenderer.charWidth(trimmedLine.charAt(i + 1));
                     }
-                    final int cWidth = this.font.getCharWidth(c);
+                    final int cWidth = this.fontRenderer.charWidth(c);
                     if (lineWidth + cWidth >= this.width) {
                         out.add(currentFormat.toString() + sb);
                         sb = new StringBuilder();
@@ -182,7 +185,7 @@ public class ScreenConsole extends Screen {
         private static final @NotNull List<@NotNull String> HISTORY = new ArrayList<>();
         private static final @Nullable RuntimeExecutor EXECUTOR = new RuntimeExecutor();
 
-        private @Nullable Font font = null;
+        private @Nullable FontRenderer fontRenderer = null;
 
         private @NotNull String text = "";
         private @NotNull String highlightedText = "";
@@ -198,7 +201,8 @@ public class ScreenConsole extends Screen {
         }
 
         public void init(final @NotNull Minecraft mc) {
-            this.font = new Font(mc, mc.gameSettings, mc.textureManager, true);
+            this.fontRenderer = new FontRendererDefault(new FontMonospace(mc.textureManager));
+            this.fontRenderer.init(mc.texturePackList);
         }
 
         public void tick() {
@@ -206,38 +210,38 @@ public class ScreenConsole extends Screen {
         }
 
         public void render(final int x, final int y) {
-            if (this.font == null) return;
+            if (this.fontRenderer == null) return;
 
             boolean addedStart = false;
             final @NotNull String @NotNull[] splitHighlighted = this.highlightedText.split("\n", -1);
             for (int i = 0; i < splitHighlighted.length; i++) {
-                drawStringNoShadow(this.font, (addedStart ? "  " : "> ") + splitHighlighted[i].replace("\n", ""), x, y + i * LINE_HEIGHT, 0xFF_E0_E0_E0);
+                drawStringNoShadow(this.fontRenderer, (addedStart ? "  " : "> ") + splitHighlighted[i].replace("\n", ""), x, y + i * LINE_HEIGHT, 0xFF_E0_E0_E0);
                 addedStart = true;
             }
 
             final @NotNull String @NotNull [] split = this.text.split("\n", -1);
-            final int offsetWidth = this.font.getStringWidth("  ");
+            final int offsetWidth = MathHelper.ceil(this.fontRenderer.stringWidthDouble("  "));
             final int[] cursorPos = getCursor();
             final int cursorX;
             if (cursorPos[0] == split[cursorPos[1]].length()) {
-                cursorX = this.font.getStringWidth(split[cursorPos[1]]);
+                cursorX = MathHelper.ceil(this.fontRenderer.stringWidthDouble(split[cursorPos[1]]));
             } else {
-                cursorX = this.font.getStringWidth(split[cursorPos[1]].substring(0, cursorPos[0]));
+                cursorX = MathHelper.ceil(this.fontRenderer.stringWidthDouble(split[cursorPos[1]].substring(0, cursorPos[0])));
             }
             if ((cursorCounter / 6) % 2 == 0) {
-                drawStringNoShadow(this.font, "█", x + offsetWidth + cursorX, y + cursorPos[1] * LINE_HEIGHT, 0xFF_FF_FF_FF);
+                drawStringNoShadow(this.fontRenderer, "█", x + offsetWidth + cursorX, y + cursorPos[1] * LINE_HEIGHT, 0xFF_FF_FF_FF);
                 if (this.editor.getCursor() < this.text.length() && this.text.charAt(this.editor.getCursor()) != '\n') {
-                    drawStringNoShadow(this.font, "" + this.text.charAt(this.editor.getCursor()), x + offsetWidth + cursorX, y + cursorPos[1] * LINE_HEIGHT, 0xFF_00_00_00);
+                    drawStringNoShadow(this.fontRenderer, "" + this.text.charAt(this.editor.getCursor()), x + offsetWidth + cursorX, y + cursorPos[1] * LINE_HEIGHT, 0xFF_00_00_00);
                 }
             } else {
-                drawStringNoShadow(this.font, "_", x + offsetWidth + cursorX, y + cursorPos[1] * LINE_HEIGHT, 0xFF_FF_FF_FF);
+                drawStringNoShadow(this.fontRenderer, "_", x + offsetWidth + cursorX, y + cursorPos[1] * LINE_HEIGHT, 0xFF_FF_FF_FF);
             }
         }
 
         public void click(final int mx, final int my) {
-            if (this.font == null) return;
+            if (this.fontRenderer == null) return;
 
-            final int oneChar = this.font.getStringWidth(" ");
+            final int oneChar = MathHelper.ceil(this.fontRenderer.stringWidthDouble(" "));
 
             final int cx = (mx - (oneChar * 2)) / oneChar;
             final int cy = my / LINE_HEIGHT;
@@ -375,7 +379,7 @@ public class ScreenConsole extends Screen {
         }
 
         private int @NotNull[] getCursor() {
-            if (this.font == null) {
+            if (this.fontRenderer == null) {
                 return new int[2];
             }
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenControllerSetup.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenControllerSetup.java
index 49512a6ab..11cc12ce4 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenControllerSetup.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenControllerSetup.java
@@ -9,8 +9,6 @@ import net.minecraft.core.lang.I18n;
 
 import java.util.Arrays;
 
-import java.util.Arrays;
-
 import static org.lwjgl.opengl.GL11.*;
 
 public class ScreenControllerSetup extends Screen {
@@ -84,7 +82,7 @@ public class ScreenControllerSetup extends Screen {
 
             glDisable(GL_DEPTH_TEST);
 
-            font.drawCenteredString("(" + controller.getType().getPrintableName() + ")", width / 2, 40, 0xFFFFFF);
+            drawStringCenteredNoShadow(fontRenderer, "(" + controller.getType().getPrintableName() + ")", width / 2, 40, 0xFFFFFF);
 
             mc.textureManager.loadTexture("/assets/minecraft/textures/gui/controller/layout.png").bind();
 
